image: xd009642/tarpaulin

before_script:
    - rustc --version

after_script:
    - bash <(curl -s https://codecov.io/bash)

stages:
    - unit_tests
    - integration_tests

test_compiler:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- compiler

test_engine:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- engine

test_types:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- types

test_tokenizer:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- tokenizer

test_xml_writer:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- xml_writer

test_symbol_table:
    stage: unit_tests
    script:
        - cargo tarpaulin --verbose --out Xml -- symbol_table

test_integration:
    stage: integration_tests
    script:
        - cargo test --test tests
